
c-------------------------------------------------------------------------------

      PROGRAM cpuSoak

      IMPLICIT none
      INTEGER i,n,niter,ierr
      CHARACTER*32 buff
      REAL, ALLOCATABLE :: t(:,:,:,:)

      INTEGER iargc
      EXTERNAL iargc,getarg

      DATA n, niter / 32, 32 /

c     Command line args

      do i = 1,iargc()
         if (i.eq.1) then
            call getarg(i,buff)
            read(buff,'(i32)',iostat=ierr) n
         else if (i.eq.2) then
            call getarg(i,buff)
            read(buff,'(i32)',iostat=ierr) niter
         endif

         if (ierr.ne.0) then
            write(0,'(a)') 'Usage: cpusoak <mesh size> <niter>'
            stop
         endif
      enddo

c     Alloc memory

      allocate(t(n,n,n,n),stat=ierr)
      if (ierr.ne.0) then
         write(0,'(a)') 'cpusoak: error allocating an ',n,'**4 array'
         stop
      endif

c     Initialise

      call Init( t,n )

c     Operate

      call Operate( t,n,niter )

      END

c-------------------------------------------------------------------------------

      SUBROUTINE Init( t,n )

      IMPLICIT none
      INTEGER n
      REAL t(n,n,n,n)

      t = 0.0
      t(1,:,:,:) = 1.0

      return
      END

c-------------------------------------------------------------------------------

      SUBROUTINE Operate( t,n,niter )

      IMPLICIT none
      INTEGER n,niter
      REAL t(n,n,n,n)

      INTEGER iter,i,j,k,l
      REAL dt,t_n

      do iter = 1,niter
         dt = 0.0

         do l = 2,n-1
            do k = 2,n-1
               do j = 2,n-1
                  do i = 2,n-1
                     t_n = t(i-1,j,k,l) + t(i+1,j,k,l)
     &                   + t(i,j-1,k,l) + t(i,j+1,k,l)
     &                   + t(i,j,k-1,l) + t(i,j,k+1,l)
     &                   + t(i,j,k,l-1) + t(i,j,k,l+1)
     &                   - t(i,j,k,l)*8.0
                     dt = max(abs(t_n),dt)
                     t(i,j,k,l) = t(i,j,k,l) + t_n/8.0
                  enddo
               enddo
            enddo
         enddo
         write(*,*) iter,dt
      enddo

      return
      END
